﻿Imports System.Runtime.InteropServices
Imports System.Drawing.Imaging

Public Class Form1

    <DllImport("AARemote.dll")> _
    Public Shared Function AASendCommand(ByVal command As Integer, ByVal parameters As String) As Integer
    End Function
    <DllImport("AARemote.dll")> _
    Public Shared Function AAReadScriptVariable(ByVal varName As String) As String
    End Function
    <DllImport("AARemote.dll")> _
    Public Shared Function AAGetPixel(ByVal x As Integer, ByVal y As Integer) As Integer
    End Function
    <DllImport("AARemote.dll")> _
    Public Shared Function AASetPixel(ByVal x As Integer, ByVal y As Integer, ByVal v As Integer) As Integer
    End Function

    Private bmp As Bitmap

    Private Sub ButOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButOpen.Click
        AASendCommand(CMD.EXECUTE, "")
        AASendCommand(CMD.SELECT_INTERFACE_62, "")  ' remove this for 6.0
    End Sub

    Private Sub ButClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButClose.Click
        AASendCommand(CMD.TERMINATE, "")
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        bmp = New Bitmap(16, 16, PixelFormat.Format32bppRgb)
    End Sub

    Private Sub butStatus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butStatus.Click
        Dim status As Integer = AASendCommand(CMD.SCRIPT_GETSTATUS, "")
        labStatus.Text = STS.AsString(status)
    End Sub

    Private Function canRunScript() As Boolean
        Dim status As Integer = AASendCommand(CMD.SCRIPT_GETSTATUS, "")
        If status <> STS.IDLE Then
            MessageBox.Show("Error: the previous script is still running.")
            Return False
        End If
        Return True
    End Function

    Private Sub butRunScript_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butRunScript.Click
        If Not canRunScript() Then
            Return
        End If
        Dim scriptString As String = textScript.Text
        AASendCommand(CMD.SCRIPT_RUN, scriptString)
    End Sub

    Private Sub butVar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butVar.Click
        labVar.Text = "= " + AAReadScriptVariable(textBoxVar.Text)
    End Sub

    Private Sub butImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butImage.Click
        Dim w As Integer = AASendCommand(CMD.IMAGE_WIDTH, "")
        Dim h As Integer = AASendCommand(CMD.IMAGE_HEIGHT, "")
        labImage.Text = w.ToString() + " x " + h.ToString()
        If w = 0 Then
            Return
        End If
        bmp = New Bitmap(w, h, PixelFormat.Format32bppRgb)
        For y As Integer = 0 To h - 1
            For x As Integer = 0 To w - 1
                Dim v As Integer = AAGetPixel(x, y)
                v = v / 50
                ' for 16 bit grayscale images this
                ' is a very simple visualization
                If v > 255 Then
                    v = 255
                End If
                ' bmp.SetPixel is VERY slow, use LockBits for real projects
                ' https://code.msdn.microsoft.com/windowsapps/BitmapLockbits-De-0b6bf1a7
                bmp.SetPixel(x, h - 1 - y, Color.FromArgb(v * &H10101))
            Next
        Next
        pictureBox1.Invalidate()
    End Sub

    Private Sub butFlip_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butFlip.Click
        If Not canRunScript() Then
            Return
        End If
        AASendCommand(CMD.SCRIPT_RUN, "Image.FlipH")
        butImage.PerformClick()
    End Sub

    Private Sub pictureBox1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pictureBox1.Paint
        e.Graphics.DrawImage(bmp, 0, 0)
    End Sub

    Private Sub ButSetPixel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButSetPixel.Click
        Dim w As Integer = AASendCommand(CMD.IMAGE_WIDTH, "")
        Dim h As Integer = AASendCommand(CMD.IMAGE_HEIGHT, "")
        If w = 0 Then
            Return
        End If
        For y As Integer = 0 To h / 2 - 1
            For x As Integer = 0 To w / 2 - 1
                Dim v As Double = Math.Sqrt(x * x + y * y) * 30.0
                AASetPixel(x, y, CInt(v))
            Next
        Next
        AASendCommand(CMD.IMAGE_UPDATE, "")
    End Sub
End Class


NotInheritable Class CMD
    Private Sub New()
    End Sub
    Public Const OK As Integer = &HAA
    Public Const EXECUTE As Integer = 0
    Public Const TERMINATE As Integer = 1
    Public Const SCRIPT_RUN As Integer = 10
    Public Const SCRIPT_STOP As Integer = 11
    Public Const SCRIPT_GETSTATUS As Integer = 12
    Public Const SCRIPT_SHOW As Integer = 13
    Public Const SCRIPT_HIDE As Integer = 14
    Public Const SCRIPT_GETVAR As Integer = 20
    Public Const IMAGE_WIDTH As Integer = 30
    Public Const IMAGE_HEIGHT As Integer = 31
    Public Const IMAGE_UPDATE As Integer = 32
    Public Const IMAGE_PREPAREUNDO As Integer = 36
    Public Const SELECT_INTERFACE_62 As Integer = 5
    Public Const SELECT_INTERFACE_60 As Integer = 4
End Class


NotInheritable Class STS
    Private Sub New()
    End Sub
    Public Const IDLE As Integer = &HA1
    Public Const RUNNING As Integer = &HA2
    Public Const CAMWAIT As Integer = &HA3
    Public Const TELEWAIT As Integer = &HA4
    Public Const FOCUSERWAIT As Integer = &HA5
    Public Const GUIDESTARWAIT As Integer = &HA6
    Public Shared Function AsString(ByVal status As Integer) As String
        Select Case status
            Case IDLE
                Return "Idle"
            Case RUNNING
                Return "Script running"
            Case CAMWAIT
                Return "Camera exposing"
            Case TELEWAIT
                Return "Telescope is moving"
            Case FOCUSERWAIT
                Return "Focuser is moving"
            Case GUIDESTARWAIT
                Return "Waiting for autoguide star"
            Case Else
                Return ("Error!")
        End Select
    End Function
End Class